//base model


@#include "var_def1.mod"

var tot_I;
var tot_S;
var pen;


%this is a policy variable (carbon tax)
varexo eps_TAU_X eps_A_Y eps_A_L eps_A_F eps_XI_Y eps_XI_L eps_XI_F eps_X;%%_F% 

@#include "base_param_new1.mod"

model;

// Eq.1 Marginal utility of consumption
lambda=(C-HABIT*C(-1))^(-RISK)-(BET*HABIT*((C(+1)-HABIT*C)^(-RISK)));

// Eq.2 Labor supply 
CHI*N^(VARPHI)=lambda*W;

// Eq.3 Euler's equation
BET*LAMBDA*RN/PI(+1)=1;

// Eq.4 Discount factor
LAMBDA=lambda(+1)/lambda;

// Eq.5 Welfare measure
U=(((C-HABIT*C(-1))^(1-RISK)-1)/(1-RISK))-CHI*(N^(1+VARPHI))/(1+VARPHI)+0.9935*U(+1);

// Eq.6 Production function sector Y
Y=(VAROMEGA_VAY^(1/EPSILON_Y)*VA_Y^(((EPSILON_Y-1)/EPSILON_Y))+VAROMEGA_E^(1/EPSILON_Y)*E^(((EPSILON_Y-1)/EPSILON_Y)))^(EPSILON_Y/(EPSILON_Y-1));

// Eq.7 Value added production sector       
VA_Y=A_Y*(XI_Y*K_Y(-1))^(ALPHA_Y)*N^(1-ALPHA_Y);

// Eq.8 Energy composite
E=((VAROMEGA_EL)^(1/EPSILON_E)*E_L^(((EPSILON_E-1)/EPSILON_E))+(VAROMEGA_EF)^(1/EPSILON_E)*E_F^(((EPSILON_E-1)/EPSILON_E)))^(EPSILON_E/(EPSILON_E-1));

// Eq.9 Total energy demand
E=MC^(EPSILON_Y)*VAROMEGA_E*Y*(P_E)^(-EPSILON_Y);

// Eq.10 Low-carbon energy demand
E_L=(VAROMEGA_EL)*E*(P_EL/P_E)^(-EPSILON_E);

// Eq.11 Fossil energy demand
E_F=(VAROMEGA_EF)*E*(P_EF/P_E)^(-EPSILON_E);

// Eq.12 NKPC
MC*SIGMA+1-SIGMA-GAMMA_P*(PI/(PI(-1)^(KAPPA_P)*PI_SS^(1-KAPPA_P))-1)*PI/(PI(-1)^(KAPPA_P)*PI_SS^(1-KAPPA_P))+BET*(LAMBDA)*GAMMA_P*(PI(+1)/(PI^(KAPPA_P)*PI_SS^(1-KAPPA_P))-1)*PI(+1)/(PI^(KAPPA_P)*PI_SS^(1-KAPPA_P))*Y(+1)/Y=0;

// Eq.13 Labor demand production sector
W=MC*Y^(1/EPSILON_Y)*VAROMEGA_VAY^(1/EPSILON_Y)*VA_Y^(((EPSILON_Y-1)/EPSILON_Y))*(1-ALPHA_Y)*1/N;

// Eq.14 Capital demand production sector   
R_Y=((Q_Y-DELTA_Y)+((MC*Y^(1/EPSILON_Y)*VAROMEGA_VAY^(1/EPSILON_Y)*VA_Y^(((EPSILON_Y-1)/EPSILON_Y))*ALPHA_Y)/(XI_Y*K_Y(-1))))*XI_Y/Q_Y(-1);

// Eq.15 Arbitrage condition production assets   
Q_Y*K_Y=Q_Y*S_Y;

// Eq.16 Capital demand low-carbon sector   
R_L=(P_EL*(E_L/(XI_L*K_L(-1)))+(Q_L-DELTA_L))*XI_L/Q_L(-1);

// Eq.17 Arbitrage condition low-carbon assets  
Q_L*K_L=Q_L*S_L;

// Eq.18 Production function low-carbon sector  
E_L=A_L*(XI_L*K_L(-1));

// Eq.19 Capital demand fossil sector     
R_F=(P_EF*E_F^(1/EPSILON_F)*VAROMEGA_VAF^(1/EPSILON_F)*VA_F^(((EPSILON_F-1)/EPSILON_F))*(1/K_F(-1))+(Q_F-DELTA_F)*XI_F)/Q_F(-1);

// Eq.20Arbitrage condition fossil assets  
Q_F*K_F=Q_F*S_F;

//Eq.21 Production function fossil sector      
E_F=(VAROMEGA_VAF^(1/EPSILON_F)*VA_F^((EPSILON_F-1)/EPSILON_F)+VAROMEGA_X^(1/EPSILON_F)*X^((EPSILON_F-1)/EPSILON_F))^(EPSILON_F/(EPSILON_F-1));

//Eq.22 Natural resource demand
P_EF*E_F^(1/EPSILON_F)*VAROMEGA_X^(1/EPSILON_F)*X^(-1/EPSILON_F)-P_X=0;

//Eq.23 Value added fossil energy                             
VA_F=A_F*(XI_F*K_F(-1));

//Eq.24 Evolution of capital production sector 
K_Y=XI_Y*K_Y(-1)+I_Y-DELTA_Y*XI_Y*K_Y(-1);

//Eq.25 Optimal net investment production sector
Q_Y=1+GAMMA_Y/2*((I_Y)/(I_Y(-1))-1)^2+GAMMA_Y*((I_Y)/(I_Y(-1))-1)*(I_Y)/(I_Y(-1))-BET*(LAMBDA)*GAMMA_Y*((I_Y(+1))/(I_Y)-1)*((I_Y(+1))/(I_Y))^2;

//Eq.26 Evolution of capital low-carbon sector 
K_L=XI_L*K_L(-1)+I_L-DELTA_L*XI_L*K_L(-1);

//Eq.27 Optimal net investment low-carbon sector
Q_L=1+GAMMA_L/2*((I_L)/(I_L(-1))-1)^2+GAMMA_L*((I_L)/(I_L(-1))-1)*(I_L)/(I_L(-1))-BET*(LAMBDA)*GAMMA_L*((I_L(+1))/(I_L)-1)*((I_L(+1))/(I_L))^2;

//Eq.28 Evolution of capital fossil sector 
K_F=XI_F*K_F(-1)+I_F-DELTA_F*XI_F*K_F(-1);

//Eq.29 Optimal net investment fossil sector
Q_F=1+GAMMA_F/2*((I_F)/(I_F(-1))-1)^2+GAMMA_F*((I_F)/(I_F(-1))-1)*(I_F)/(I_F(-1))-BET*(LAMBDA)*GAMMA_F*((I_F(+1))/(I_F)-1)*((I_F(+1))/(I_F))^2;

//Eq.30 Balance sheet                      
Q_Y*S_YP+Q_L*S_LP+Q_F*S_FP=NW+B_P;

//Eq.31 Total net worth
NW=NW_E+NW_NEW;

//Eq.32 Net worth of new bankers
NW_NEW=OMEGA*(Q_Y*S_YP(-1)+Q_L*S_LP(-1)+Q_F*S_FP(-1));

//Eq.33 Net worth of existing bankers
NW_E=THETA*((R_Y-R(-1))*(Q_Y(-1)*S_YP(-1)/NW(-1))+(R_L-R(-1))*(Q_L(-1)*S_LP(-1)/NW(-1))+(R_F-R(-1))*(Q_F(-1)*S_FP(-1)/NW(-1))+R(-1))*NW(-1);

//Eq.34 Risk-adjusted private leverage ratio
PHI=(Q_Y*S_YP+PSI_L*Q_L*S_LP+PSI_F*Q_F*S_FP)/NW;

//Eq.35 Marginal value of net worth
NU=(RHO*BET*(LAMBDA)*((1-THETA)+THETA*NU(+1))*(R))/(RHO-(BET*(LAMBDA)*((1-THETA)+THETA*NU(+1)))*(R_Y(+1)-R));

//Eq.36 Bank objective function
V=NU*NW;

//Eq.37
PSI_L*(LAMBDA)*((1-THETA)+THETA*NU(+1))*(R_Y(+1)-R)=(LAMBDA)*((1-THETA)+THETA*NU(+1))*(R_L(+1)-R);

//Eq.38 
PSI_F*(LAMBDA)*((1-THETA)+THETA*NU(+1))*(R_L(+1)-R)=PSI_L*(LAMBDA)*((1-THETA)+THETA*NU(+1))*(R_F(+1)-R);

//Eq.39 
PHI=NU/RHO;

//Eq.40 Government budget constraint        
G=T+TAU_X*X+R_Y*Q_Y*S_YG(-1)+R_F*Q_F*S_FG(-1)+R_L*Q_L*S_LG(-1)-R(-1)*B_G(-1);

//Eq.41 Taylor rule
(RN/RN_SS)=((RN(-1)/RN_SS)^(KAPPA_RN)*(((PI/PI_SS)^KAPPA_PI)*((Y/Y(-1))^KAPPA_Y))^(1-KAPPA_RN));

//Eq.42 Fisher equation  
RN=R*PI(+1);

//Eq.43 Aggregate resource constraint       
Y=C+G+I_Y+I_L+I_F+GAMMA_Y/2*((I_Y)/(I_Y(-1))-1)^2*(I_Y)+GAMMA_L/2*((I_L)/(I_L(-1))-1)^2*(I_L)+GAMMA_F/2*((I_F)/(I_F(-1))-1)^2*(I_F)+Y*GAMMA_P/2*(PI/(PI(-1)^(KAPPA_P)*PI_SS^(1-KAPPA_P))-1)^2;

//Eq.44 Public consumption
C_G=C_G_SS;

//Eq.45 Total assets production sector
S_Y=S_YP+S_YG;

//Eq.46 Total assets fossil sectors
S_F=S_FP+S_FG;

//Eq.47 Total assets low-carbon sector
S_L=S_LP+S_LG;

//Eq.48 Fraction of production assets intermediated via central bank
Q_Y*S_YG=CREDIT_Y*(Q_Y*S_Y);

//Eq.49 Fraction of fossil assets intermediated via central bank
Q_F*S_FG=CREDIT_F*(Q_F*S_F);

//Eq.50 Fraction of low-carbon assets intermediated via central bank
Q_L*S_LG=CREDIT_L*(Q_L*S_L);

//Eq.51 Public bonds issued to finance credit policy      
Q_Y*S_YG+Q_L*S_LG+Q_F*S_FG=B_G;

//Eq.52 Total deposits
B=B_G+B_P;

//Eq. 53 Carbon tax / emission mitigation                            
P_X=P_X_SS+TAU_X;

//Eq.54 Credit policy production sector
CREDIT_Y=CREDIT_Y_SS;

//Eq.55 Credit policy low-carbon sector
CREDIT_L=CREDIT_L_SS;

//Eq.56 Credit policy fossil sector
CREDIT_F=CREDIT_F_SS;

//Eq.57 carbon tax
TAU_X=TAU_X_SS+TAU_X_SHOCK;

//Eq.58 Technology production sector
A_Y=A_Y_SS*exp(A_Y_SHOCK);

//Eq.59 Technology fossil sector
A_F=A_F_SS*exp(A_F_SHOCK);

//Eq.60 Technology low-carbon sector
A_L=A_L_SS*exp(A_L_SHOCK);

//Eq.61 Leverage (non-risk adjusted)
LEV=(Q_Y*S_YP+Q_L*S_LP+Q_F*S_FP)/NW;

//Eq.62 Spread production sector
SPREAD_Y=R_Y(+1)-R;    
        
//Eq.63 Spread low-carbon sector
SPREAD_L=R_L(+1)-R;

//Eq.64 Spread fossil sector
SPREAD_F=R_F(+1)-R;

//Eq.65 Government expenditures
G=C_G+TAU_CP*(Q_Y*S_YG+Q_L*S_LG+Q_F*S_FG);

//Eq.66 Capital quality production sector
XI_Y=XI_Y_SS*exp(XI_Y_SHOCK);

//Eq.67 Capital quality low-carbon sector
XI_L=XI_L_SS*exp(XI_L_SHOCK);

//Eq.68 Capital quality fossil sector
XI_F=XI_F_SS*exp(XI_F_SHOCK);

//Eq.69 Exogenous shock process on technology fossil sector
A_F_SHOCK=RHO_AF*A_F_SHOCK(-1)+eps_A_F;

//Eq.70 Exogenous shock process on technology low-carbon sector
A_L_SHOCK=RHO_AL*A_L_SHOCK(-1)+eps_A_L;

//Eq.71 Exogenous shock process on technology fossil sector
A_Y_SHOCK=RHO_AY*A_Y_SHOCK(-1)+eps_A_Y;
  
//Eq.72 Exogenous shock process on capital quality production sector
XI_Y_SHOCK=RHO_XIY*XI_Y_SHOCK(-1)-eps_XI_Y-0.05*eps_XI_F;

//Eq.73 Exogenous shock process on capital quality low-carbon sector
XI_L_SHOCK=RHO_XIL*XI_L_SHOCK(-1)+eps_XI_L-eps_XI_Y;

//Eq.74 Exogenous shock process on capital quality fossil sector
XI_F_SHOCK=RHO_XIF*XI_F_SHOCK(-1)-eps_XI_F-eps_XI_Y;

//Eq. 75 emission process
X_SHOCK=RHO_X*X_SHOCK(-1)+eps_X;

//Eq. 76 carbon tax process 
TAU_X_SHOCK=0.9*TAU_X_SHOCK(-1)+eps_TAU_X+eps_TAU_X(-1)
+eps_TAU_X(-2)+eps_TAU_X(-3)+eps_TAU_X(-4)+eps_TAU_X(-5)
+eps_TAU_X(-6)+eps_TAU_X(-7)+eps_TAU_X(-8)+eps_TAU_X(-9)
+eps_TAU_X(-10)+eps_TAU_X(-11)+eps_TAU_X(-12)
+eps_TAU_X(-13)+eps_TAU_X(-14)+eps_TAU_X(-15)
+eps_TAU_X(-16)+eps_TAU_X(-17)+eps_TAU_X(-18)
+eps_TAU_X(-19)+eps_TAU_X(-20)+eps_TAU_X(-21)
+eps_TAU_X(-22)+eps_TAU_X(-23)+eps_TAU_X(-24)+eps_TAU_X(-25)
+eps_TAU_X(-26)+eps_TAU_X(-27)+eps_TAU_X(-28)
+eps_TAU_X(-29)
+eps_TAU_X(-30)+eps_TAU_X(-31)+eps_TAU_X(-32)
+eps_TAU_X(-33)+eps_TAU_X(-34)+eps_TAU_X(-35)
+eps_TAU_X(-36)+eps_TAU_X(-37)+eps_TAU_X(-38)+eps_TAU_X(-39);

//Eq. 77
tot_I=I_F+I_L+I_Y;

//Eq. 78
tot_S=Q_F*S_F+Q_L*S_L+Q_Y*S_Y;

//Eq. 79
pen=P_E*E;

//
Y_tilde=log(Y);

//
C_tilde=log(C);


//Eq. 81
PI_obs=PI-steady_state(PI);

//Eq. 85
R_obs=R-steady_state(R);

//Eq. 82
Y_obs=Y_tilde-steady_state(Y_tilde);

//Eq. 83
C_obs=C_tilde-steady_state(C_tilde);

end;

initval;
   
    B=B_SS;                  % total deposits
    B_P=B_P_SS;              % private deposits/bank deposits
    B_G=B_G_SS;              % public bonds issued to finance credit policy
    C=C_SS;                  % consumption
    C_G=C_G_SS;              % public consumption 
    E=E_SS;                  % energy aggregate
    E_F=E_F_SS;              % fossil energy
    E_L=E_L_SS;              % low-carbon energy
    I_F=I_F_SS;              % investment fossil sector
    I_L=I_L_SS;              % investment low-carbon sector
    I_Y=I_Y_SS;              % investment production sector 
    K_F=K_F_SS;              % total capital fossil sector 
    K_L=K_L_SS;              % capital low-carbon sector
    K_Y=K_Y_SS;              % capital production sector
    lambda=lambda_SS;        % Lagrange multiplier
    LAMBDA=LAMBDA_SS;        % households' stochastic discount factor
    MC=MC_SS;                % marginal costs production sector
    N=N_SS;                  % labor production sector
    NU=NU_SS;                % marginal value of net worth
    NW=NW_SS;                % net worth
    NW_E=NW_E_SS;            % net worth existing bankers
    NW_NEW=NW_NEW_SS;        % net worth new bankers
    P_E=P_E_SS;              % real aggregate energy price
    P_EF=P_EF_SS;            % real fossil energy price
    P_EL=P_EL_SS;            % real low-carbon energy price
    PHI=PHI_SS;              % leverage ratio
    PI=PI_SS;                % inflation
    P_X=P_X_SS;              % carbon price            
    Q_F=Q_F_SS;              % price of capital fossil sector
    Q_L=Q_L_SS;              % price of capital low-carbon sector
    Q_Y=Q_Y_SS;              % price of capital production sector
    R=R_SS;                  % real interest rate
    R_F=R_F_SS;              % stochastic return on fossil sector's assets
    R_L=R_L_SS;              % stochastic returns on low-carbon sector's assets
    R_Y=R_Y_SS;              % stochastic return on production sector's assets     
    RN=RN_SS;                % nominal interest rate   N.B. in the tex file RN=(1+i) 
    S_F=S_F_SS;              % total intermediated assets fossil sector
    S_L=S_L_SS;              % total intermediated assets low-carbon sector
    S_Y=S_Y_SS;              % total intermediated assets production sector
    S_FP=S_FP_SS;            % privately intermediated assets fossil sector
    S_LP=S_LP_SS;            % privately intermediated low-carbon sector
    S_YP=S_YP_SS;            % privately intermediated assets production sector
    S_FG=S_FG_SS;            % assets fossil sector intermediated via government assistance
    S_LG=S_LG_SS;            % assets low-carbon sector intermediated via government assistance
    S_YG=S_YG_SS;            % assets production sector intermediated via government assistance
    T=T_SS;                  % lump-sum taxes
    U=U_SS;                  % utility
    V=V_SS;                  % loss supported by bankers/value function
    VA_Y=VA_Y_SS;            % value added production sector
    VA_F=VA_F_SS;            % value added fossil sector
    W=W_SS;              % real wage production sector
    X=X_SS;                  % extraction/emissions flow
    Y=Y_SS;                  % production 
    CREDIT_L=CREDIT_L_SS;    % credit policy low-carbon sector
    CREDIT_F=CREDIT_F_SS;    % credit policy fossil sector
    CREDIT_Y=CREDIT_Y_SS;    % credit policy production sector
    TAU_X=TAU_X_SS;          % extraction/emissions flow
    A_F=A_F_SS;                % technology fossil sector
    A_L=A_L_SS;              % technology low-carbon sector
    A_Y=A_Y_SS;              % technology
    LEV=LEV_SS;              %leverage ration (non-risk adjusted)
    SPREAD_Y=SPREAD_Y_SS;    % spread= return on Y - safe rate
    SPREAD_F=SPREAD_F_SS;    % spread= return on F - safe rate
    SPREAD_L=SPREAD_L_SS;    % spread= return on L - safe rate
    G=G_SS;                  % total public expenditure
    XI_F=XI_F_SS;            % quality of capital fossil sector
    XI_L=XI_L_SS;            % quality of capital low-carbon sector
    XI_Y=XI_Y_SS;            % quality of capital production sector
    A_F_SHOCK=0;             % tech process fossil sector
    A_L_SHOCK=0;             % tech process low-carbon sector
    A_Y_SHOCK=0;             % tech process production sector
    XI_F_SHOCK=0;            % capital quality process fossil sector
    XI_L_SHOCK=0;            % capital quality process low-carbon sector
    XI_Y_SHOCK=0;            % capital quality process production sector
    X_SHOCK=0;               % emission shock
    tot_I=I_F_SS+I_L_SS+I_Y_SS;  %total investments
    tot_S=S_F_SS+S_L_SS+S_Y_SS;  %total investments
    pen=P_E_SS*E_SS;
 end;

shocks;
var eps_TAU_X=0.0104443^2;
var eps_A_Y=0.007;
var eps_A_L=0.0246;
var eps_A_F=0.0246;
var eps_XI_Y=0.032;
var eps_XI_L=0.0043; 
var eps_XI_F=0.0041;
var eps_X=0.001; 
end;

estimated_params;
RHO_AY,beta_pdf,0.8,0.1;
RHO_AL,beta_pdf,0.8,0.1;
RHO_AF,beta_pdf,0.8,0.1;
RHO_XIF,beta_pdf,0.8,0.1;
RHO_XIL,beta_pdf,0.8,0.1;
RHO_XIY,beta_pdf,0.8,0.1;
end;

model_diagnostics;
resid(1);
steady;
check;

varobs PI_obs Y_obs R_obs C_obs;
identification;

%stoch_simul(irf=41,nograph,noprint,order=1);
estimation(datafile=LSS,mode_check,mode_compute=6,mh_replic=2000,mh_nblocks=2,mh_jscale=0.8,mh_nblock=2,mcmc_jumping_covariance=identity_matrix,bayesian_irf);

resid;
model_diagnostics;
check;

X_eps_TAU_X(40)/X_SS*100;%TAU_X(40)
P_X40=P_X_eps_TAU_X(40)+P_X_SS

%Cumulative emissions
X_SS=0.033;
X_base=((matrix_MIT(30,1:40).*X_SS)./100)+X_SS;
X_base_cum=sum(X_base);
X_SS_cum=X_SS*40;
(X_base_cum-X_SS_cum)*100/X_SS_cum



